明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 304|回复: 6

【求助】请教把选择集加入块的方法或者代码!!!

[复制链接]
发表于 2018-3-7 13:19 | 显示全部楼层 |阅读模式
本帖最后由 dong20030432 于 2018-3-7 14:53 编辑

自己用VB做一个程序,需要把选择集中的实体放到块中,在网上查到用copyobjects方法,但运行过程中总是报错(最后一行),请大家帮忙看下怎么回事。如果有其它方法,麻烦告诉我一下,感激不尽,谢谢了!!!
  1. Dim NoNamBlo As AcadBlock
  2. Dim BasePnt As Variant
  3. Dim Ent() As Object
  4. Dim ownName As String
  5. On Error Resume Next
  6. Set sset = AcadApp.ActiveDocument.SelectionSets.Item("ss1")
  7. sset.Delete
  8. Set sset = AcadApp.ActiveDocument.SelectionSets.Add("ss1")
  9. AppActivate AcadApp.Caption
  10. AcadApp.ActiveDocument.Utility.Prompt "请选择要建立块的对象"
  11. sset.SelectOnScreen
  12. BasePnt = AcadApp.ActiveDocument.Utility.GetPoint(, "请拾取块基点")
  13. Set NoNamBlo = AcadApp.ActiveDocument.Blocks.Add(BasePnt, "*u")
  14. ownName = NoNamBlo.Name
  15. ReDim Ent(sset.Count)
  16. For i = 0 To sset.Count - 1
  17. Set Ent(i) = sset.Item(i)
  18. Next
  19. AcadApp.ActiveDocument.CopyObjects Ent, NoNamBlo






本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有帐号?注册

x
发表于 2018-3-7 14:20 | 显示全部楼层
你想直接把对象拷贝到块里去?copyobjects是拷贝到模型/图纸空间。
 楼主| 发表于 2018-3-7 14:50 | 显示全部楼层
本帖最后由 dong20030432 于 2018-3-7 14:51 编辑
mikewolf2k 发表于 2018-3-7 14:20
你想直接把对象拷贝到块里去?copyobjects是拷贝到模型/图纸空间。

感谢您的回复!
我查到的资料和一些零散的代码有说能拷贝到块里面或者模型空间里面。

activex和VBA手册中也说这个Owner参数是个单对象,应该也包括块吧?
如果您有其它方法,请告诉我一下,谢谢了!我不一定要用copyobjects的,只要能实现功能就行。

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有帐号?注册

x
发表于 2018-3-7 15:36 | 显示全部楼层
ReDim Ent(sset.Count-1)
 楼主| 发表于 2018-3-7 15:45 | 显示全部楼层
zzyong00 发表于 2018-3-7 15:36
ReDim Ent(sset.Count-1)

哦,我的天呀,非常感谢大神!!!原来是太粗心了,以后一定要仔细!
发表于 2018-3-7 16:05 | 显示全部楼层
dong20030432 发表于 2018-3-7 14:50
感谢您的回复!
我查到的资料和一些零散的代码有说能拷贝到块里面或者模型空间里面。

可以拷贝到块么?没用过。学一招。谢谢!
 楼主| 发表于 2018-3-7 17:04 | 显示全部楼层
mikewolf2k 发表于 2018-3-7 16:05
可以拷贝到块么?没用过。学一招。谢谢!

用这个方法确实可以实现,我一开始写错了代码。
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2017 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2018-6-21 20:01 , Processed in 0.161355 second(s), 28 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表